def GetFace(host, api, api_key, surname, uid = '0', firstname = '0', middlename = '0'):
    '''
    Описываем функцию, где обязательные параметры host, api и api_key отвечают за формирование url,
    обязательный параметр surname соотвествует фамилии пользователя,
    остальные параметры (uid - id пользователя, firstname - имя, middlename - отчетство) являются необязательными.
    '''
    import json # импортируем библиотеку для работы с json
    import requests # импортируем библиотеку для работы с http
    url = ''.join([str(host), str(api), 'api_key=', str(api_key)]) # формируем полный url
    response = requests.get(url) # создание подключения
    response.encoding = 'utf-8'
    data = response.json() # сохранение данных в json
    if uid == '':
        uid = 0
    else:
        uid = int(uid or 0)
    if firstname == '':
        firstname = '0'
    if middlename == '':
        middlename = '0'
    ### Валидация
    assert isinstance(uid, int), 'EmpGUID  should be an int'
    assert isinstance(surname, str) and surname.isspace() != True, 'surname should be a non-space string'
    assert isinstance(surname, str) and surname, 'Введите фамилию сотрудника'
    assert isinstance(firstname, str) and firstname.isspace() != True, 'firstname should be a non-space string'
    assert isinstance(middlename, str) and middlename.isspace() != True, 'middlename should be a non-space string'
    ### Валидация
    face = [] # пустой список для добавления найденных результатов
    main_cond = "f['SurName'] == surname" # главное условие поиска
    name_params = ["f['EmpGUID']", "f['FirstName']", "f['MiddleName']"] # имена параметров в json
    params = [str(uid), str(firstname), str(middlename)] # список передаваемых параметров
    conditions = [] # пустой список для дополнительный условий поиска
    for i in range(len(params)):
        if params[i] != str(0):
            conditions.append('and str({}) == "{}"'.format(name_params[i], params[i].strip()))
    other_cond = ' '.join([x for x in conditions])
    search = main_cond + ' ' + other_cond
    for f in data: # цикл поиска по каждому элементу списка в data
        if eval(search): # условие поиска
            face.append(f) # добавляем найденные данные в список
    with open('face.json', 'w') as write_file: # создание пустого файла для записи
        json.dump(face, write_file) # запись найденного содержимого в json файл
    if len(face) == 0: # обработка исключений
        print('Сотрудник не найден') # вывод сообщения в случае отсутствия совпадений   

