# -*- coding: utf-8 -*-
"""
Definition of views.
"""
from django.views.generic import TemplateView
from django.shortcuts import render, redirect
from django.http import HttpRequest
from django.template import RequestContext
from django.http import HttpResponse
from datetime import datetime
import requests
import pandas
import json
import uuid
import pprint
from .GetFace_Function import GetFace
from .GetFormular_Function import GetFormular
from pandas.io.json import json_normalize
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator

# Function GetEmpoyee
def GetEmployee(host, api_face, api_formular, api_key, surname, uid = 0, firstname = '0', middlename = '0'):
    GetFace(host, api_face, api_key, surname, uid, firstname, middlename)
    GetFormular(host, api_formular, api_key, surname, uid, firstname, middlename)
    employee = [] #создаем список
    with open('face.json', 'r') as face_file: #открывем файл
        data_face = json.load(face_file) #перемещаем содержимое файла в переменную
        
    with open('formular.json', 'r') as formular_file:
        data_formular = json.load(formular_file)
    
    for face in data_face: #цикл по data_face
        employee.append([face]) #добавляем первый элемент в пустой список
        for formular in data_formular: #создаем цикл по data_formular
            if str(face['EmpGUID']) == formular['EmpGUID']: # проверяем равенство id
                employee[-1].append(formular) # если равны, то к массиву face добавляем массив formular
    fn = str(uuid.uuid4())
    with open('temp/{}.json'.format(fn), 'w') as write_file: # создание пустого файла для записи
        json.dump(employee, write_file) # записывем файл
        
    if len(employee) == 0: # обработка исключений
        print('Сотрудник не найден') # вывод сообщения в случае отсутствия совпадений
    else:
        with open('temp/{}.json'.format(fn)) as file:
            data_old = json.load(file)
            data=[]
            for dd in data_old:
                for d in dd:
                    data.append(d)
        df = json_normalize(data)
        nedata = df[['EmpGUID', 'SurName', 'FirstName',
               'MiddleName','BirthDay','Name_podr','Name']].sort_values(by=['SurName',
                                           'FirstName'])
        nedata.columns = ['EmpGUID', 'Фамилия', 'Имя', 'Отчество', 'Дата рождения',
                          'Наименование подразделения', 'Должность']
        nedata = nedata.fillna('Нет', axis=1)
        return nedata.to_html(index=False)

from app.forms import ContactForm
from django.views.generic.edit import FormView

class FindForm(FormView):
    template_name = 'form.html'
    form_class = ContactForm
    success_url = '/thanks/'

    @method_decorator(login_required(login_url='/'))
    def dispatch(self, *args, **kwargs):
        return super().dispatch(*args, **kwargs)

    def form_valid(self, form):
        a = GetEmployee(host='https://sd.mephi.ru/', api_face='api/1/faces.json?', api_formular='api/1/formulars.json?', api_key='bai7phaxief4iecooTh:eeke', firstname=form.cleaned_data['firstname'],
                    surname=form.cleaned_data['surname'], middlename=form.cleaned_data['middlename'],
                    uid=form.cleaned_data['uid'])
        return render(
            self.request,
            'form.html',
            {
                'title': 'Form Page',
                'year': datetime.now().year,
                'table': a,
            }
        )
class RedirectView(TemplateView):
    template_name = 'index.html'
    def get(self, request, *args, **kwargs):
        if request.user.is_authenticated:
            return redirect(to='form.html')
        return super().get(request, *args, **kwargs)